"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const js_yaml_1 = __importDefault(require("js-yaml"));
const replaceVariable = (value, env) => {
    if (typeof value !== 'string')
        return value;
    const reg = new RegExp('\\$\\(env\\:(.*)\\)', 'g');
    return value.replace(reg, (_, p1) => {
        if (!Object.keys(env).includes(p1)) {
            throw new Error('env variable ' + p1 + ' must be set');
        }
        return env[p1];
    });
};
exports.default = (content, env) => {
    const data = js_yaml_1.default.safeLoad(content.toString());
    return JSON.parse(JSON.stringify(data), function (_, value) {
        return replaceVariable(value, env);
    });
};
