"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_pick_1 = __importDefault(require("lodash.pick"));
const decode_1 = __importDefault(require("./decode"));
const mapToArray = (inputs) => Object.keys(inputs || {}).map(key => (Object.assign(Object.assign({}, inputs[key]), { key })));
const parseParams = (params) => mapToArray(params).map(x => (Object.assign(Object.assign({}, lodash_pick_1.default(x, ['key', 'name', 'description', 'type', 'repeated', 'optional'])), { object: parseParams(x.object) })));
exports.default = (content) => __awaiter(void 0, void 0, void 0, function* () {
    const definition = decode_1.default(content, {});
    return Object.assign(Object.assign({}, lodash_pick_1.default(definition, ['sid', 'name', 'description', 'repository'])), { configuration: definition.configuration || {}, dependencies: mapToArray(definition.dependencies), tasks: mapToArray(definition.tasks).map(x => (Object.assign(Object.assign({}, lodash_pick_1.default(x, ['key', 'name', 'description'])), { inputs: parseParams(x.inputs), outputs: parseParams(x.outputs) }))), events: mapToArray(definition.events).map(x => (Object.assign(Object.assign({}, lodash_pick_1.default(x, ['key', 'name', 'description'])), { data: parseParams(x.data) }))) });
});
