"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ajv_1 = __importDefault(require("ajv"));
exports.default = (schema, data) => {
    const validate = new ajv_1.default({
        jsonPointers: true
    }).compile(schema);
    if (validate(data))
        return;
    const error = validate.errors.reduce((prev, error) => `${prev}\n${error.dataPath} ${error.message}`, "");
    throw new Error(error);
};
